/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 2.0.12
 *
 * This file is not intended to be easily readable and contains a number of
 * coding conventions designed to improve portability and efficiency. Do not make
 * changes to this file unless you know what you are doing--modify the SWIG
 * interface file instead.
 * ----------------------------------------------------------------------------- */

#define SWIGJAVA

/* -----------------------------------------------------------------------------
 *  This section contains generic SWIG labels for method/variable
 *  declarations/attributes, and other compiler dependent labels.
 * ----------------------------------------------------------------------------- */

/* template workaround for compilers that cannot correctly implement the C++ standard */
#ifndef SWIGTEMPLATEDISAMBIGUATOR
# if defined(__SUNPRO_CC) && (__SUNPRO_CC <= 0x560)
#  define SWIGTEMPLATEDISAMBIGUATOR template
# elif defined(__HP_aCC)
/* Needed even with `aCC -AA' when `aCC -V' reports HP ANSI C++ B3910B A.03.55 */
/* If we find a maximum version that requires this, the test would be __HP_aCC <= 35500 for A.03.55 */
#  define SWIGTEMPLATEDISAMBIGUATOR template
# else
#  define SWIGTEMPLATEDISAMBIGUATOR
# endif
#endif

/* inline attribute */
#ifndef SWIGINLINE
# if defined(__cplusplus) || (defined(__GNUC__) && !defined(__STRICT_ANSI__))
#   define SWIGINLINE inline
# else
#   define SWIGINLINE
# endif
#endif

/* attribute recognised by some compilers to avoid 'unused' warnings */
#ifndef SWIGUNUSED
# if defined(__GNUC__)
#   if !(defined(__cplusplus)) || (__GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 4))
#     define SWIGUNUSED __attribute__ ((__unused__))
#   else
#     define SWIGUNUSED
#   endif
# elif defined(__ICC)
#   define SWIGUNUSED __attribute__ ((__unused__))
# else
#   define SWIGUNUSED
# endif
#endif

#ifndef SWIG_MSC_UNSUPPRESS_4505
# if defined(_MSC_VER)
#   pragma warning(disable : 4505) /* unreferenced local function has been removed */
# endif
#endif

#ifndef SWIGUNUSEDPARM
# ifdef __cplusplus
#   define SWIGUNUSEDPARM(p)
# else
#   define SWIGUNUSEDPARM(p) p SWIGUNUSED
# endif
#endif

/* internal SWIG method */
#ifndef SWIGINTERN
# define SWIGINTERN static SWIGUNUSED
#endif

/* internal inline SWIG method */
#ifndef SWIGINTERNINLINE
# define SWIGINTERNINLINE SWIGINTERN SWIGINLINE
#endif

/* exporting methods */
#if (__GNUC__ >= 4) || (__GNUC__ == 3 && __GNUC_MINOR__ >= 4)
#  ifndef GCC_HASCLASSVISIBILITY
#    define GCC_HASCLASSVISIBILITY
#  endif
#endif

#ifndef SWIGEXPORT
# if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
#   if defined(STATIC_LINKED)
#     define SWIGEXPORT
#   else
#     define SWIGEXPORT __declspec(dllexport)
#   endif
# else
#   if defined(__GNUC__) && defined(GCC_HASCLASSVISIBILITY)
#     define SWIGEXPORT __attribute__ ((visibility("default")))
#   else
#     define SWIGEXPORT
#   endif
# endif
#endif

/* calling conventions for Windows */
#ifndef SWIGSTDCALL
# if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
#   define SWIGSTDCALL __stdcall
# else
#   define SWIGSTDCALL
# endif
#endif

/* Deal with Microsoft's attempt at deprecating C standard runtime functions */
#if !defined(SWIG_NO_CRT_SECURE_NO_DEPRECATE) && defined(_MSC_VER) && !defined(_CRT_SECURE_NO_DEPRECATE)
# define _CRT_SECURE_NO_DEPRECATE
#endif

/* Deal with Microsoft's attempt at deprecating methods in the standard C++ library */
#if !defined(SWIG_NO_SCL_SECURE_NO_DEPRECATE) && defined(_MSC_VER) && !defined(_SCL_SECURE_NO_DEPRECATE)
# define _SCL_SECURE_NO_DEPRECATE
#endif



/* Fix for jlong on some versions of gcc on Windows */
#if defined(__GNUC__) && !defined(__INTEL_COMPILER)
  typedef long long __int64;
#endif

/* Fix for jlong on 64-bit x86 Solaris */
#if defined(__x86_64)
# ifdef _LP64
#   undef _LP64
# endif
#endif

#include <jni.h>
#include <stdlib.h>
#include <string.h>


/* Support for throwing Java exceptions */
typedef enum {
  SWIG_JavaOutOfMemoryError = 1, 
  SWIG_JavaIOException, 
  SWIG_JavaRuntimeException, 
  SWIG_JavaIndexOutOfBoundsException,
  SWIG_JavaArithmeticException,
  SWIG_JavaIllegalArgumentException,
  SWIG_JavaNullPointerException,
  SWIG_JavaDirectorPureVirtual,
  SWIG_JavaUnknownError
} SWIG_JavaExceptionCodes;

typedef struct {
  SWIG_JavaExceptionCodes code;
  const char *java_exception;
} SWIG_JavaExceptions_t;


static void SWIGUNUSED SWIG_JavaThrowException(JNIEnv *jenv, SWIG_JavaExceptionCodes code, const char *msg) {
  jclass excep;
  static const SWIG_JavaExceptions_t java_exceptions[] = {
    { SWIG_JavaOutOfMemoryError, "java/lang/OutOfMemoryError" },
    { SWIG_JavaIOException, "java/io/IOException" },
    { SWIG_JavaRuntimeException, "java/lang/RuntimeException" },
    { SWIG_JavaIndexOutOfBoundsException, "java/lang/IndexOutOfBoundsException" },
    { SWIG_JavaArithmeticException, "java/lang/ArithmeticException" },
    { SWIG_JavaIllegalArgumentException, "java/lang/IllegalArgumentException" },
    { SWIG_JavaNullPointerException, "java/lang/NullPointerException" },
    { SWIG_JavaDirectorPureVirtual, "java/lang/RuntimeException" },
    { SWIG_JavaUnknownError,  "java/lang/UnknownError" },
    { (SWIG_JavaExceptionCodes)0,  "java/lang/UnknownError" }
  };
  const SWIG_JavaExceptions_t *except_ptr = java_exceptions;

  while (except_ptr->code != code && except_ptr->code)
    except_ptr++;

  (*jenv)->ExceptionClear(jenv);
  excep = (*jenv)->FindClass(jenv, except_ptr->java_exception);
  if (excep)
    (*jenv)->ThrowNew(jenv, excep, msg);
}


/* Contract support */

#define SWIG_contract_assert(nullreturn, expr, msg) if (!(expr)) {SWIG_JavaThrowException(jenv, SWIG_JavaIllegalArgumentException, msg); return nullreturn; } else


#include "lbfgsb_wrapper.h"


static int *new_intArray(int nelements) { 
  return (int *) calloc(nelements,sizeof(int)); 
}

static void delete_intArray(int *ary) { 
  free(ary); 
}

static int intArray_getitem(int *ary, int index) {
    return ary[index];
}
static void intArray_setitem(int *ary, int index, int value) {
    ary[index] = value;
}


static double *new_doubleArray(int nelements) { 
  return (double *) calloc(nelements,sizeof(double)); 
}

static void delete_doubleArray(double *ary) { 
  free(ary); 
}

static double doubleArray_getitem(double *ary, int index) {
    return ary[index];
}
static void doubleArray_setitem(double *ary, int index, double value) {
    ary[index] = value;
}


#ifdef __cplusplus
extern "C" {
#endif

SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_new_1intArray(JNIEnv *jenv, jclass jcls, jint jarg1) {
  jlong jresult = 0 ;
  int arg1 ;
  int *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  arg1 = (int)jarg1; 
  result = (int *)new_intArray(arg1);
  *(int **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_delete_1intArray(JNIEnv *jenv, jclass jcls, jlong jarg1) {
  int *arg1 = (int *) 0 ;
  
  (void)jenv;
  (void)jcls;
  arg1 = *(int **)&jarg1; 
  delete_intArray(arg1);
}


SWIGEXPORT jint JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_intArray_1getitem(JNIEnv *jenv, jclass jcls, jlong jarg1, jint jarg2) {
  jint jresult = 0 ;
  int *arg1 = (int *) 0 ;
  int arg2 ;
  int result;
  
  (void)jenv;
  (void)jcls;
  arg1 = *(int **)&jarg1; 
  arg2 = (int)jarg2; 
  result = (int)intArray_getitem(arg1,arg2);
  jresult = (jint)result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_intArray_1setitem(JNIEnv *jenv, jclass jcls, jlong jarg1, jint jarg2, jint jarg3) {
  int *arg1 = (int *) 0 ;
  int arg2 ;
  int arg3 ;
  
  (void)jenv;
  (void)jcls;
  arg1 = *(int **)&jarg1; 
  arg2 = (int)jarg2; 
  arg3 = (int)jarg3; 
  intArray_setitem(arg1,arg2,arg3);
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_new_1doubleArray(JNIEnv *jenv, jclass jcls, jint jarg1) {
  jlong jresult = 0 ;
  int arg1 ;
  double *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  arg1 = (int)jarg1; 
  result = (double *)new_doubleArray(arg1);
  *(double **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_delete_1doubleArray(JNIEnv *jenv, jclass jcls, jlong jarg1) {
  double *arg1 = (double *) 0 ;
  
  (void)jenv;
  (void)jcls;
  arg1 = *(double **)&jarg1; 
  delete_doubleArray(arg1);
}


SWIGEXPORT jdouble JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_doubleArray_1getitem(JNIEnv *jenv, jclass jcls, jlong jarg1, jint jarg2) {
  jdouble jresult = 0 ;
  double *arg1 = (double *) 0 ;
  int arg2 ;
  double result;
  
  (void)jenv;
  (void)jcls;
  arg1 = *(double **)&jarg1; 
  arg2 = (int)jarg2; 
  result = (double)doubleArray_getitem(arg1,arg2);
  jresult = (jdouble)result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_doubleArray_1setitem(JNIEnv *jenv, jclass jcls, jlong jarg1, jint jarg2, jdouble jarg3) {
  double *arg1 = (double *) 0 ;
  int arg2 ;
  double arg3 ;
  
  (void)jenv;
  (void)jcls;
  arg1 = *(double **)&jarg1; 
  arg2 = (int)jarg2; 
  arg3 = (double)jarg3; 
  doubleArray_setitem(arg1,arg2,arg3);
}


SWIGEXPORT jint JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_LBFGSB_1TASK_1SIZE_1get(JNIEnv *jenv, jclass jcls) {
  jint jresult = 0 ;
  int result;
  
  (void)jenv;
  (void)jcls;
  result = (int)(60);
  jresult = (jint)result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1n_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jint jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int arg2 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = (int)jarg2; 
  if (arg1) (arg1)->n = arg2;
}


SWIGEXPORT jint JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1n_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jint jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int result;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (int) ((arg1)->n);
  jresult = (jint)result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1m_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jint jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int arg2 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = (int)jarg2; 
  if (arg1) (arg1)->m = arg2;
}


SWIGEXPORT jint JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1m_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jint jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int result;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (int) ((arg1)->m);
  jresult = (jint)result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1x_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jlong jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double *arg2 = (double *) 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = *(double **)&jarg2; 
  if (arg1) (arg1)->x = arg2;
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1x_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jlong jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (double *) ((arg1)->x);
  *(double **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1l_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jlong jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double *arg2 = (double *) 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = *(double **)&jarg2; 
  if (arg1) (arg1)->l = arg2;
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1l_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jlong jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (double *) ((arg1)->l);
  *(double **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1u_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jlong jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double *arg2 = (double *) 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = *(double **)&jarg2; 
  if (arg1) (arg1)->u = arg2;
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1u_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jlong jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (double *) ((arg1)->u);
  *(double **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1nbd_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jlong jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int *arg2 = (int *) 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = *(int **)&jarg2; 
  if (arg1) (arg1)->nbd = arg2;
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1nbd_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jlong jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (int *) ((arg1)->nbd);
  *(int **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1f_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jdouble jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double arg2 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = (double)jarg2; 
  if (arg1) (arg1)->f = arg2;
}


SWIGEXPORT jdouble JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1f_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jdouble jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double result;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (double) ((arg1)->f);
  jresult = (jdouble)result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1g_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jlong jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double *arg2 = (double *) 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = *(double **)&jarg2; 
  if (arg1) (arg1)->g = arg2;
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1g_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jlong jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (double *) ((arg1)->g);
  *(double **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1factr_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jdouble jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double arg2 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = (double)jarg2; 
  if (arg1) (arg1)->factr = arg2;
}


SWIGEXPORT jdouble JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1factr_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jdouble jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double result;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (double) ((arg1)->factr);
  jresult = (jdouble)result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1pgtol_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jdouble jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double arg2 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = (double)jarg2; 
  if (arg1) (arg1)->pgtol = arg2;
}


SWIGEXPORT jdouble JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1pgtol_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jdouble jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double result;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (double) ((arg1)->pgtol);
  jresult = (jdouble)result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1wa_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jlong jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double *arg2 = (double *) 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = *(double **)&jarg2; 
  if (arg1) (arg1)->wa = arg2;
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1wa_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jlong jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (double *) ((arg1)->wa);
  *(double **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1iwa_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jlong jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int *arg2 = (int *) 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = *(int **)&jarg2; 
  if (arg1) (arg1)->iwa = arg2;
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1iwa_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jlong jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (int *) ((arg1)->iwa);
  *(int **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1task_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jstring jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  char *arg2 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = 0;
  if (jarg2) {
    arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
    if (!arg2) return ;
  }
  {
    if(arg2) {
      strncpy((char*)arg1->task, (const char *)arg2, 60+1-1);
      arg1->task[60+1-1] = 0;
    } else {
      arg1->task[0] = 0;
    }
  }
  
  if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, (const char *)arg2);
}


SWIGEXPORT jstring JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1task_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jstring jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  char *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (char *)(char *) ((arg1)->task);
  if (result) jresult = (*jenv)->NewStringUTF(jenv, (const char *)result);
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1iprint_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jint jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int arg2 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = (int)jarg2; 
  if (arg1) (arg1)->iprint = arg2;
}


SWIGEXPORT jint JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1iprint_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jint jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int result;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (int) ((arg1)->iprint);
  jresult = (jint)result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1csave_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jstring jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  char *arg2 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = 0;
  if (jarg2) {
    arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
    if (!arg2) return ;
  }
  {
    if(arg2) {
      strncpy((char*)arg1->csave, (const char *)arg2, 60-1);
      arg1->csave[60-1] = 0;
    } else {
      arg1->csave[0] = 0;
    }
  }
  
  if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, (const char *)arg2);
}


SWIGEXPORT jstring JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1csave_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jstring jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  char *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (char *)(char *) ((arg1)->csave);
  if (result) jresult = (*jenv)->NewStringUTF(jenv, (const char *)result);
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1lsave_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jlong jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int *arg2 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = *(int **)&jarg2; 
  {
    size_t ii;
    int *b = (int *) arg1->lsave;
    for (ii = 0; ii < (size_t)4; ii++) b[ii] = *((int *) arg2 + ii);
  }
  
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1lsave_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jlong jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (int *)(int *) ((arg1)->lsave);
  *(int **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1isave_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jlong jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int *arg2 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = *(int **)&jarg2; 
  {
    size_t ii;
    int *b = (int *) arg1->isave;
    for (ii = 0; ii < (size_t)44; ii++) b[ii] = *((int *) arg2 + ii);
  }
  
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1isave_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jlong jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  int *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (int *)(int *) ((arg1)->isave);
  *(int **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1dsave_1set(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jlong jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double *arg2 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = *(double **)&jarg2; 
  {
    size_t ii;
    double *b = (double *) arg1->dsave;
    for (ii = 0; ii < (size_t)29; ii++) b[ii] = *((double *) arg2 + ii);
  }
  
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1dsave_1get(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jlong jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  double *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (double *)(double *) ((arg1)->dsave);
  *(double **)&jresult = result; 
  return jresult;
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_new_1lbfgsb(JNIEnv *jenv, jclass jcls) {
  jlong jresult = 0 ;
  struct lbfgsb *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  result = (struct lbfgsb *)calloc(1, sizeof(struct lbfgsb));
  *(struct lbfgsb **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_delete_1lbfgsb(JNIEnv *jenv, jclass jcls, jlong jarg1) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  
  (void)jenv;
  (void)jcls;
  arg1 = *(struct lbfgsb **)&jarg1; 
  free((char *) arg1);
}


SWIGEXPORT jlong JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1create(JNIEnv *jenv, jclass jcls, jint jarg1, jint jarg2) {
  jlong jresult = 0 ;
  int arg1 ;
  int arg2 ;
  struct lbfgsb *result = 0 ;
  
  (void)jenv;
  (void)jcls;
  arg1 = (int)jarg1; 
  arg2 = (int)jarg2; 
  result = (struct lbfgsb *)lbfgsb_create(arg1,arg2);
  *(struct lbfgsb **)&jresult = result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1delete(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  lbfgsb_delete(arg1);
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1step(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  lbfgsb_step(arg1);
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1set_1task(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jint jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  enum lbfgsb_task_type arg2 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = (enum lbfgsb_task_type)jarg2; 
  lbfgsb_set_task(arg1,arg2);
}


SWIGEXPORT jint JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1get_1task(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_) {
  jint jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  enum lbfgsb_task_type result;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  result = (enum lbfgsb_task_type)lbfgsb_get_task(arg1);
  jresult = (jint)result; 
  return jresult;
}


SWIGEXPORT void JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1set_1task_1str(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jstring jarg2) {
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  char *arg2 = (char *) 0 ;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = 0;
  if (jarg2) {
    arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
    if (!arg2) return ;
  }
  lbfgsb_set_task_str(arg1,arg2);
  if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, (const char *)arg2);
}


SWIGEXPORT jint JNICALL Java_lbfgsb_jniwrapper_lbfgsb_1wrapperJNI_lbfgsb_1is_1task_1str_1equal(JNIEnv *jenv, jclass jcls, jlong jarg1, jobject jarg1_, jstring jarg2) {
  jint jresult = 0 ;
  struct lbfgsb *arg1 = (struct lbfgsb *) 0 ;
  char *arg2 = (char *) 0 ;
  int result;
  
  (void)jenv;
  (void)jcls;
  (void)jarg1_;
  arg1 = *(struct lbfgsb **)&jarg1; 
  arg2 = 0;
  if (jarg2) {
    arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
    if (!arg2) return 0;
  }
  result = (int)lbfgsb_is_task_str_equal(arg1,arg2);
  jresult = (jint)result; 
  if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, (const char *)arg2);
  return jresult;
}


#ifdef __cplusplus
}
#endif

